#include "wmithread.h"

WmiThread::WmiThread(QObject *parent) :
    QThread(parent)
{
    connect(&process, SIGNAL(readyReadStandardOutput()), this, SLOT(readStandartProcessOutput()));
    connect(&process, SIGNAL(readyReadStandardError()), this, SLOT(readStandartProcessError()));
    mutex.lock();
    stopped = false;
    mutex.unlock();



}

void WmiThread::run(){



    QString query_string;
    error = false; //  
    query_string = tr("wmic -U ");
    query_string.append(user_name);
    query_string.append(tr("%"));
    query_string.append(password);
    query_string.append(tr(" //"));
    query_string.append(host);
    query_string.append(tr(" \""));
    query_string.append(wmi_string);
    query_string.append(tr("\""));
    process.start(query_string);

    while (!stopped);
  //  exec();
}

void WmiThread::stop(){
      mutex.lock();
      stopped = true;
      mutex.unlock();
}

void WmiThread::readStandartProcessOutput(){
p_buffer = process.readAllStandardOutput();
mutex.lock();
stopped = true;
mutex.unlock();
}

void WmiThread::readStandartProcessError(){
p_buffer = process.readAllStandardError();
error = true; //  ,     WMI-
}
